<?php
add_action( 'wp_ajax_wpstream_check_server_against_db', 'wpstream_check_server_against_db' );  
function wpstream_check_server_against_db(){
    $show_id    =   intval($_POST['show_id']);
    $is_live    =   false;
    
    $live_event_for_user    =   wpstream_get_live_event_for_user();
    if(isset($live_event_for_user[$show_id])) {
       $is_live=true;   
    }
    
    echo json_encode( array('islive' =>$is_live) );
    exit();
}



function wpstream_get_videos(){
    $current_user       =   wp_get_current_user();
    $allowded_html      =   array();
    $userID             =   $current_user->ID;
    $return_uri         =   '';
    if( !current_user_can('administrator') ){
       exit('');
    }
    $video_data         =   wpstream_get_videos_from_storage();
    return $video_data;
}





function wpstream_get_pack_details_user(){
    $current_user       =   wp_get_current_user();
    $allowded_html      =   array();
    $userID             =   $current_user->ID;
    $return_uri         =   '';
    if( !current_user_can('administrator') ){
        exit('');
    }
    $pack_data         =   wpstream_request_pack_data_per_user();       
    return $pack_data;
}




function wpstream_get_live_event_for_user(){
    $current_user       =   wp_get_current_user();
    $allowded_html      =   array();
    $userID             =   $current_user->ID;
    $return_uri         =   '';
    if( !current_user_can('administrator') ){
       exit('');
    }
    $event_data         =   wpstream_request_live_stream_for_user($userID);
    return $event_data;
}




add_action( 'wp_ajax_wpstream_close_event', 'wpstream_close_event' );  
function wpstream_close_event(){
    check_ajax_referer( 'wpstream_start_event_nonce', 'security' );
    $current_user       =   wp_get_current_user();
    $allowded_html      =   array();
    $userID             =   $current_user->ID;
    $return_uri         =   '';
    if( !current_user_can('administrator') ){
       exit('okko');
    }

    $show_id            =   intval($_POST['show_id']);

    update_post_meta ($show_id,'event_passed',1);

    die();
}





add_action( 'wp_ajax_wpstream_give_me_live_uri', 'wpstream_give_me_live_uri' );  
function wpstream_give_me_live_uri(){

    check_ajax_referer( 'wpstream_start_event_nonce', 'security' );
    $current_user       =   wp_get_current_user();
    $allowded_html      =   array();
    $userID             =   $current_user->ID;
    $return_uri         =   '';

    if( !current_user_can('administrator') ){
       exit('okko');
    }

    $show_id            =   intval($_POST['show_id']);
    $is_record          =   floatval($_POST['is_record']);
    
    
    
    
    $event_data         =   wpstream_request_live_stream_uri($show_id,$is_record);

   
    
    if(is_array($event_data)){
        $explode                =   explode('wpstream.net/',  $event_data['live_uri']);
        $uri                    =   $explode[0].'wpstream.net/wpstream/';
        $server_status_check    = 
        $stream_key             =   trim(str_replace('wpstream/',' ',$explode[1]));
        
        
        update_post_meta($show_id,'live_event_uri', $event_data['live_uri']);
        update_post_meta($show_id,'live_event_stream_name', $event_data['carnat1']);
        update_post_meta($show_id,'ip', $event_data['ip']);
        
        
        
        if( isset($event_data['dns_change_id']) && $event_data['dns_change_id']!='' ){
           
                echo json_encode(   array(
                    'sometihng'             =>  'mr',
                    'conected'              =>  true,
                    'caster_url'            =>  $event_data['webcaster_url'],
                    'live_uri'              =>  $event_data['live_uri'] ,
                    'all_data'              =>  $event_data,
                    'obs_uri'               =>  $event_data['live_uri2'],
                    'obs_stream'            =>  $stream_key,
                    'server_status_check'   =>  'http://'.$event_data['ip'].':8444' ,
                    'ip'                    =>  $event_data['ip'],
                    'subdomain_key'         =>  $event_data['subdomain_key'],
                    'dns_change_id'         =>  $event_data['dns_change_id']
                    )
                );
            
        }else{
            echo json_encode(   array(
                'error' =>'No dns change id'
            ));
        }
  
    }else{
        echo json_encode(   array(
            'error' =>'no answer'
        ));
    }
    die();
}




function wpstream_get_videos_from_storage(){

    if( !current_user_can('administrator') ){
        exit('okko');
    }
    $token          =   wpstream_rcapi_retrive_token();
    $values_array   =   array();
    $url            =   WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/videos/get_list_row/?access_token=".$token;


    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
    $response       = wp_remote_post($url,$arguments);
    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);

   

    if( isset($response['response']['code']) && $response['response']['code']=='200'){
        $video_options=array();
        foreach ($received_data as $key=>$videos){
           $video_options[$videos['video_name_storage']]=$videos['video_name_storage'].'';
        }
       
        return $video_options;
    }else{     
        return 'failed connection';
    }

}





add_action( 'wp_ajax_wpstream_get_delete_file', 'wpstream_get_delete_file' );  
function wpstream_get_delete_file(){
    if( !current_user_can('administrator') ){
        exit('okko');
    }
    
    $video_name     =   esc_html($_POST['video_name']);
    $token          =   wpstream_rcapi_retrive_token();
    $values_array   =   array();
    $values_array['video_name'] =   $video_name;
    
    $url            =   WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/videos/get_delete_file/?access_token=".$token;


    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
    $response       = wp_remote_post($url,$arguments);

    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);


    if( isset($response['response']['code']) && $response['response']['code']=='200'){
        print $received_data;
    }else{     
        return 'failed connection';
    }
    exit();
    
    
}


add_action( 'wp_ajax_wpstream_get_download_link', 'wpstream_get_download_link' );  
function wpstream_get_download_link(){
    if( !current_user_can('administrator') ){
        exit('okko');
    }
    
    $video_name=esc_html($_POST['video_name']);
    $token          =   wpstream_rcapi_retrive_token();
    $values_array   =   array();
    $values_array['video_name'] =   $video_name;
    
    $url            =   WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/videos/get_download_link/?access_token=".$token;


    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
    $response       = wp_remote_post($url,$arguments);
 

    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);

  


    if( isset($response['response']['code']) && $response['response']['code']=='200'){
        print trim($received_data);
    }else{     
        return 'failed connection';
    }
    exit();
    
    
}



add_action( 'wp_ajax_wpstream_update_video_status', 'wpstream_update_video_status' );  
function wpstream_update_video_status(){
    if( !current_user_can('administrator') ){
        exit('okko');
    }
    
    $video_id           =   intval($_POST['video_id']);
    $status             =   intval($_POST['status']);
    $video_name         =   esc_html($_POST['video_name']);
    $video_name_storage =   esc_html($_POST['video_name_storage']);
    
    $token          =   wpstream_rcapi_retrive_token();
    $values_array   =   array();
    $values_array['video_id']   =   $video_id;
    $values_array['status']     =   $status;
    $values_array['video_name'] =   $video_name;
    $values_array['video_name_storage']=$video_name_storage;
    
    
    $url            =   WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/videos/update_video_status/?access_token=".$token;


    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
    $response       = wp_remote_post($url,$arguments);
    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);

  


    if( isset($response['response']['code']) && $response['response']['code']=='200'){
        return $received_data;
    }else{     
        return 'failed connection';
    }
    exit();
    
    
}

function wpstream_get_signed_form_upload_data(){
    if( !current_user_can('administrator') ){
        exit('okko');
    }
    
    $token          =   wpstream_rcapi_retrive_token();
    $values_array   =   array();
    $url            =   WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/videos/get_upload_form/?access_token=".$token;


    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
    $response       = wp_remote_post($url,$arguments);
    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);



    if( isset($response['response']['code']) && $response['response']['code']=='200'){
        return $received_data;
    }else{     
        return 'failed connection';
    }
}

function wpstream_get_videos_from_storage_raw_data(){

    if( !current_user_can('administrator') ){
        exit('okko');
    }
    $token          =   wpstream_rcapi_retrive_token();
    $values_array   =   array();
    $url            =   WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/videos/get_list_row/?access_token=".$token;


    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
    $response       = wp_remote_post($url,$arguments);
 
    
    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);



    if( isset($response['response']['code']) && $response['response']['code']=='200'){
        return $received_data;
    }else{     
        return 'failed connection';
    }

}



function wpstream_request_pack_data_per_user(){

    if( !current_user_can('administrator') ){
        exit('okko');
    }
    $token          =   wpstream_rcapi_retrive_token();
    $values_array   =   array();
    $url            =   WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/status/packdetails/?access_token=".$token;


    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
    $response       = wp_remote_post($url,$arguments);
    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);



    if( isset($response['response']['code']) && $response['response']['code']=='200'){
       return ($received_data);
    }else{     
        return 'failed connection';
    }

}


function wpstream_request_live_stream_for_user($user_id){
    if( !current_user_can('administrator') ){
        exit('okko');
    }
    $domain = parse_url ( get_site_url() );
    $token  = wpstream_rcapi_retrive_token();

    $values_array=array(
        "show_id"           =>  $user_id,
        "scheme"            =>  $domain['scheme'],
        "domain"            =>  $domain['host'],
        "domain_ip"         =>  $_SERVER['SERVER_ADDR']
    );



    $url=WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/livestrem/peruser/?access_token=".$token;


    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
    $response       = wp_remote_post($url,$arguments);
    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);

    if(is_wp_error($response)){
        return 'failed connection';
    }
    if( isset($response['response']['code']) && $response['response']['code']=='200'){
       return ($received_data);
    }else{     
        return 'failed connection';
    }

}



add_action( 'wp_ajax_wpstream_check_dns_sync', 'wpstream_check_dns_sync' );
function wpstream_check_dns_sync(){
    $token  = wpstream_rcapi_retrive_token();
   

    $values_array=array(
        "dns_change_id"           =>  esc_html($_POST['change_id']),
    );

    $url=WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/checkdns/get/?access_token=".$token;


    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
   

    
    $response       = wp_remote_post($url,$arguments);
    
    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);
 
  
    
   
    if( isset($response['response']['code']) && $response['response']['code']=='200'){
        print ($received_data);
    }else{     
       // print 'failed connection';
    }
    die();
}





function wpstream_request_live_stream_uri($show_id,$is_record){    
    $token  = wpstream_rcapi_retrive_token();
    $domain = parse_url ( get_site_url() );

    $values_array=array(
        "show_id"           =>  $show_id,
        "scheme"            =>  $domain['scheme'],
        "domain"            =>  $domain['host'],
        "domain_ip"         =>  $_SERVER['SERVER_ADDR'],
        "is_record"         =>  $is_record,
        "location"          =>  get_home_url()   
    );

    $url=WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/livestrem/new/?access_token=".$token;


    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
    $response       = wp_remote_post($url,$arguments);
    
    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);
 
  

   
    if( isset($response['response']['code']) && $response['response']['code']=='200'){
       return ($received_data);
    }else{     
        return 'failed connection';
    }

}



function wpstream_rcapi_retrive_token(){
    $token =  get_transient('wpstream_token_request');
    if ( false === $token || $token==='' ) {
        $token = wpstream_club_get_token();
        set_transient( 'wpstream_token_request', $token ,600);
    }

    return $token;

}



function wpstream_club_get_token(){

    $client_id      = esc_html ( get_option('wpstream_api_key','') );
    $client_secret  = esc_html ( get_option('wpstream_api_secret_key','') );
    $username       = esc_html ( get_option('wpstream_api_username','') );
    $password       = esc_html ( get_option('wpstream_api_password','') );

    if ( $username=='' || $password==''){
        return;
    }
    $curl = curl_init();

    curl_setopt_array($curl, array(
    CURLOPT_URL => WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/?oauth=token",
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "POST",
    CURLOPT_POSTFIELDS => "grant_type=password&username=".$username."&password=".$password,
    CURLOPT_HTTPHEADER => array(
        "authorization: Basic ". base64_encode( '$client_id' . ':' . '$client_secret' ),
        "cache-control: no-cache",
        "content-type: application/x-www-form-urlencoded",
        "postman-token: 3d65984a-9f80-a881-5fe9-59717126687e"
        ),
    ));

    $response = curl_exec($curl);
    $err = curl_error($curl);

    curl_close($curl);
    $response= json_decode($response);

    if(isset($response->access_token)){
        return $response->access_token;
    }else{
        return;
    }
}





function wpstream_client_check_api_status(){

        $token= wpstream_rcapi_retrive_token();
        
        $url=WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/status/?access_token=".$token;
        $arguments = array(
            'method' => 'GET',
            'timeout' => 45,
            'redirection' => 5,
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => array(),
            'cookies' => array()
        );
        $response   =   wp_remote_post($url,$arguments);
        $body       =   wp_remote_retrieve_body($response);

        if ( $body === true || $body ==='true'){
            return true;
        }else{
            return false;
        } 
}



function wpstream_retrive_username(){
        $token= wpstream_rcapi_retrive_token();
        
        $url=WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/return_login/?access_token=".$token;
        $arguments = array(
            'method' => 'GET',
            'timeout' => 45,
            'redirection' => 5,
            'httpversion' => '1.0',
            'blocking' => true,
            'headers' => array(),
            'cookies' => array()
        );
        $response   =   wp_remote_post($url,$arguments);
    
        $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);

        
        if( isset($response['response']['code']) && $response['response']['code']=='200'){
            return ($received_data); die(); 
        }else{     
            print 'Failed to conbect media server';
            die(); 
        }
       

        
}

function  wpstream_get_live_stream_server($current_user,$streamname){
   
    $token          =   wpstream_rcapi_retrive_token();
    $values_array   =   array();
    $values_array['new_stream']     =   $streamname;
    
    $url            =   WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/livestrem/get_server_ip/?access_token=".$token;
    

    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
    $response       = wp_remote_post($url,$arguments);

   
    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);

    if( isset($response['response']['code']) && $response['response']['code']=='200'){
        return trim($received_data);
    }else{     
        return 'failed connection';
    }
    exit();
    
}




function wpstream_request_hls_player($product_id){
   
    
    $show_id        =   intval($product_id);
    $token          =   wpstream_rcapi_retrive_token();
    $values_array   =   array();
    $values_array['show_id'] =   $show_id;
    
    $url            =   WPSTREAM_CLUBLINKSSL."://www.".WPSTREAM_CLUBLINK."/wp-json/rcapi/v1/videos/get_player_hls/?access_token=".$token;


    $arguments = array(
        'method'        => 'GET',
        'timeout'       => 45,
        'redirection'   => 5,
        'httpversion'   => '1.0',
        'blocking'      => true,
        'headers'       => array(),
        'body'          => $values_array,
        'cookies'       => array()
    );
    $response       = wp_remote_post($url,$arguments);

    $received_data  = json_decode( wp_remote_retrieve_body($response) ,true);

  


    if( isset($response['response']['code']) && $response['response']['code']=='200'){
        return trim($received_data);
    }else{     
        return 'failed connection';
    }
    exit();
    
    
}

