<?php
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    add_action( 'init', 'wpstream_register_live_stream_product_type' );
}

function wpstream_register_live_stream_product_type(){
    class WC_Product_Live_Stream extends WC_Product{

        public function __construct( $product ) {
            parent::__construct( $product );
              $this->supports[]   = 'ajax_add_to_cart';
        }

        // Needed since Woocommerce version 3
        public function get_type() {
            return 'live_stream';
        }
    }
}

if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    add_action( 'init', 'wpstream_register_video_on_demand_product_type' );
}

function wpstream_register_video_on_demand_product_type() {
    class WC_Product_Video_On_Demand extends WC_Product {
        public function __construct( $product ) {
            parent::__construct( $product );
              $this->supports[]   = 'ajax_add_to_cart';
        }

        public function get_type() {
            return 'video_on_demand';
        }
    }

}



function wpstream_add_products( $types ){
    $types[ 'live_stream' ]             = __( 'Live Channel','wpestream' );
    $types[ 'video_on_demand' ]         = __( 'Video On Demand','wpestream' );
    if( isset( $_GET['new_video_name']) && $_GET['new_video_name']!=''  ){
        array_unshift($types,'Macarena');
    }
    return $types;
}
add_filter( 'product_type_selector', 'wpstream_add_products' );



function wpstream_products_custom_js() {

  
    if ( 'product' != get_post_type() ) :
        return;
    endif;

    ?>
    <script type='text/javascript'>
        jQuery( document ).ready( function() {
            jQuery( '.options_group.pricing' ).addClass ( 'show_if_live_stream' ).show();
            jQuery( '.options_group.pricing' ).addClass ( 'show_if_video_on_demand' ).show();

            var selected = jQuery('#product-type').val();
        

        });
 
    </script>
    <?php

}
add_action( 'admin_footer', 'wpstream_products_custom_js' );





function wpstream_hide_attributes_data_panel( $tabs) {
    $tabs['shipping']['class'][] = 'hide_if_live_stream  hide_if_video_on_demand';
    $tabs['general']['class'][] = 'show_if_live_stream show_if_video_on_demand';
    
    return $tabs;
}
add_filter( 'woocommerce_product_data_tabs', 'wpstream_hide_attributes_data_panel',10,1 );











function wpstream_add_custom_general_fields() {

    global $woocommerce, $post;
    if(function_exists('wcs_user_has_subscription')){
        echo '<div class="options_group   show_if_subscription">';  
            woocommerce_wp_select( 
                array( 
                    'id'      =>    '_subscript_live_event', 
                    'label'   =>    __( 'Is a subscription based live channel ?', 'woocommerce' ), 
                    'options' =>    array("yes"=>"yes","no"=>"no")
                    )
                );
        echo '</div>';
    }

    echo '<div class="options_group show_if_live_stream" style="border:none;"></div>';  
    echo '<div class="options_group show_if_video_on_demand">';  
        $selected='';
        if( isset( $_GET['new_video_name']) && $_GET['new_video_name']!=''  ){
            $selected=esc_html($_GET['new_video_name']);
        }
        if($selected==''){
           $selected= get_post_meta($post->ID,'_movie_url',true);
        }
        
        woocommerce_wp_select( 
            array( 
                'id'      =>    '_movie_url', 
                'label'   =>    __( 'Select the video file.', 'woocommerce' ), 
                'options' =>    wpstream_get_videos(),
                'selected'=>    true,
                'value'    =>   $selected
                )
        );

    echo '</div>';

    
    
    
}
add_filter( 'woocommerce_product_options_general_product_data', 'wpstream_add_custom_general_fields' );




function wpstream_add_custom_general_fields_save( $post_id ){

    $permited_values = array(
        '_movie_url',
        '_subscript_live_event'
    );
    $allowed_html=array();
    foreach($_POST as $key=>$value){
        update_post_meta( $post_id, 'event_passed', 0 );
        if( in_array($key, $permited_values) ){
            if( !empty( $_POST[$key] ) ){
                update_post_meta( $post_id, wp_kses ($key,$allowed_html), wp_kses ( $_POST[$key],$allowed_html) );
            }
        }
    }

}
add_filter( 'woocommerce_process_product_meta', 'wpstream_add_custom_general_fields_save' );



function wpstream_add_to_cart() {
    wc_get_template( 'single-product/add-to-cart/simple.php' );
}

add_action('woocommerce_live_stream_add_to_cart',  'wpstream_add_to_cart');
add_action('woocommerce_video_on_demand_add_to_cart',  'wpstream_add_to_cart');


//add_action( 'woocommerce_after_shop_loop_item', 'woocommerce_template_loop_add_to_cart' );


//add_filter( 'woocommerce_product_add_to_cart_text' , 'custom_woocommerce_product_add_to_cart_text' ,10,2);

function custom_woocommerce_product_add_to_cart_text( $var, $instance ) {
	global $product;
	

        $product_type = $product->get_type();
	
	if($product_type==='live_stream' || $product_type=='video_on_demand'){
            return __( 'Add to Cart', 'woocommerce' );
	}else{
            return $var;
        }
	
}


add_filter( 'woocommerce_loop_add_to_cart_link', 'replacing_add_to_cart_button', 10, 2 );
function replacing_add_to_cart_button( $button, $product  ) {
    global $product;
	

    $product_type = $product->get_type();

    if($product_type==='live_stream' || $product_type=='video_on_demand'){
        return $button = '<a class="button" href="'.get_site_url().'/shop/?add-to-cart=' .$product->get_id(). '&quantity=1">' . __( 'Add to Cart', 'woocommerce' ) . '</a>';
    }else{
        return $button;
    }

  


}