<?php

function wpstream_main_start(){
    
    add_action( 'wp_enqueue_scripts', 'wpstream_enqueue_styles' );
    add_action( 'admin_enqueue_scripts', 'wpstream_enqueue_styles_admin'); 
    add_action( 'init', 'wpstream_my_custom_endpoints' );
    add_filter( 'query_vars', 'wpstream_my_custom_query_vars', 0 );
    add_filter( 'woocommerce_account_menu_items', 'wpstream_custom_my_account_menu_items' );
    add_action( 'woocommerce_account_event-list_endpoint', 'wpstream_custom_endpoint_content_event_list' );
    add_action( 'woocommerce_account_video-list_endpoint', 'wpstream_custom_endpoint_video_list' );
    add_action( 'woocommerce_before_single_product', 'wpstream_user_logged_in_product_already_bought', 10 );
    add_action( 'after_switch_theme', 'wpstream_custom_flush_rewrite_rules' );
    add_action('init', 'wpstream_shortcodes');
    
    if (is_admin()) {
        add_action('admin_menu', 'wpstream_manage_admin_menu',999);
    }
    
    $page_check = get_page_by_title('wpstream');
    if (!isset($page_check->ID)) {
        $my_post = array(
            'post_title'    => 'wpstream',
            'post_type'     => 'page',
            'post_status'   => 'publish',
        );
        $new_id = wp_insert_post($my_post);

    }
    
    $page_check = get_page_by_title('vodkey');
    if (!isset($page_check->ID)) {
        $my_post = array(
            'post_title'    => 'vodkey',
            'post_type'     => 'page',
            'post_status'   => 'publish',
        );
        $new_id = wp_insert_post($my_post);

    }
    
    $page_check = get_page_by_title('Userkey');
    if (!isset($page_check->ID)) {
        $my_post = array(
            'post_title'    => 'Userkey',
            'post_type'     => 'page',
            'post_status'   => 'publish',
        );
        $new_id = wp_insert_post($my_post);

    }
        
        
}




function wpstream_manage_admin_menu() {
    
    add_menu_page( __('WpStream','wpestream'), __('WpStream ','wpstream'), 'administrator', 'wpstream_plugin_options', 'wpstream_set_wpstream_credentials');
    
    add_submenu_page( 'wpstream_plugin_options', __('WpStream Options','wpestream'),          __('WpStream Options','wpestream'),          'administrator', 'wpstream_plugin_options',  'wpstream_set_wpstream_credentials');
    add_submenu_page( 'wpstream_plugin_options', __('WpStream Channels','wpestream'),         __('WpStream Channels','wpestream'),          'administrator', 'wpstream_new_general_set',  'wpstream_new_general_set');
    add_submenu_page( 'wpstream_plugin_options', __('WpStream Media Management','wpestream'), __('WpStream Media Management','wpestream'),  'administrator', 'wpstream_media_management', 'wpstream_media_management');

       
}



function wpstream_non_image_content_wrapper_start() {
    if ( is_user_logged_in() ) {
        global $product;
        $current_user   =   wp_get_current_user();
        $product_id     =   wc_get_product()->get_id();

        if ( wc_customer_bought_product( $current_user->user_email, $current_user->ID, $product_id) ){
            echo '<div id="wpstream_product_wrap">';
        }else{
            echo '<div id="wpstream_product_wrap_no_buy">';
        }
    }

}



function wpstream_non_image_content_wrapper_end() { 
   // echo '</div>';
}


add_action( 'woocommerce_before_single_product', 'wpstream_non_image_content_wrapper_start', 20 );
add_action( 'woocommerce_after_single_product', 'wpstream_non_image_content_wrapper_end', 20 );
 